// $Id: Gandharva.cpp,v 1.35 2002/08/28 11:07:06 Yoshi Exp $
// Copyright (C) 2000-2002 HOSHINO Yoshifumi
// {vO̓t[E\tgEFAłBρEĔzz GNU GPL o[WQ
// i͂ȍ~jQƂĂB

#define WIN32_LEAN_AND_MEAN
#define STRICT

#include <windowsx.h>


#include <tchar.h>
#include "lsapi.h"
#include "Gandharva.h"
#include "GandharvaSettings.h"
#include "cmdprovider.h"
#include "ampcmd.h"
#include "winampfunc.h"
#include "winamp3func.h"

char buildname[]	= "Gandharva.dll";
char buildver[]		= "0.40.1.1";
char builddate[]	= "2002/08/28";
char buildauthor[]	= "Yoshi";

UINT nMessages[] = {LM_GETREVID,0};


DISPATCH_BANGCOMMAND(bangToggleVisible,	USERBM_TOGGLE)
DISPATCH_BANGCOMMAND(bangToggleTime,	USERBM_TOGGLE_TIME)
DISPATCH_BANGCOMMAND(bangShow,			USERBM_SHOW)
DISPATCH_BANGCOMMAND(bangHide,			USERBM_HIDE)
DISPATCH_BANGCOMMAND(bangDispMenu,		USERBM_DISPMENU)
DISPATCH_BANGCOMMAND(bangRunSndvol,		USERBM_SNDVOL)
DISPATCH_BANGCOMMAND(bangAmpPower,  	USERBM_AMP_POWER)
DISPATCH_BANGCOMMAND(bangAmpCommand,	USERBM_AMP_COMMANDEX)
DISPATCH_BANGCOMMAND(bangToggleOnTop,   USERBM_TOGGLE_ONTOP)
DISPATCH_BANGCOMMAND(bangOnTop,			USERBM_ONTOP)
DISPATCH_BANGCOMMAND(bangNotOnTop,		USERBM_NOT_ONTOP)

DISPATCH_BANGCOMMAND(bangAmpPrev,		AMPAPI_CMD_PREV)
DISPATCH_BANGCOMMAND(bangAmpPlay,		AMPAPI_CMD_PLAY)
DISPATCH_BANGCOMMAND(bangAmpPause,		AMPAPI_CMD_PAUSE)
DISPATCH_BANGCOMMAND(bangAmpStop,		AMPAPI_CMD_STOP)
DISPATCH_BANGCOMMAND(bangAmpNext,		AMPAPI_CMD_NEXT)
DISPATCH_BANGCOMMAND(bangAmpPLEdit,		AMPAPI_CMD_PLEDIT)
DISPATCH_BANGCOMMAND(bangAmpOpenFile,	AMPAPI_CMD_OPENFILE)



/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
    RXgN^
        EBhẼZbgAbv
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
Gandharva::Gandharva( HWND parent, HINSTANCE lsinstance )
{
  //xxxxxxxxxxxxxxxxxxxxVXȅ
  m_hLitestep = GetLitestepWnd();
  m_hInstance = lsinstance;
  m_hDesktop = FindWindow(WC_LSDESKTOP, NULL);
  if(!m_hDesktop)
    m_hDesktop = GetDesktopWindow();

  m_stimer = 0;
  m_rtimer = 0;
  m_wtimer = 0;
  
  m_token = -1;
  
  m_pPlayer = NULL;

  m_nWaitCounter = 0;

  //xxxxxxxxxxxxxxxxxxxxEChENX
  WNDCLASSEX wc;

  wc.cbSize = sizeof(WNDCLASSEX);
  wc.style = CS_DBLCLKS | CS_GLOBALCLASS;
  wc.lpfnWndProc = (WNDPROC) Gandharva::WndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 4;
  wc.hInstance = m_hInstance;
  wc.hCursor = LoadCursor( NULL, IDC_ARROW );
  wc.hIcon = NULL;
  wc.hIconSm = NULL;
  wc.hbrBackground = NULL;
  wc.lpszMenuName = NULL;
  wc.lpszClassName = WINDOWCLASS_DLL;

  if (!RegisterClassEx( &wc ) ) {
    MessageBox(0,TEXT("failed to register window class."),WINDOWCLASS_DLL,MB_OK|MB_SYSTEMMODAL);
    return;
  }

  //xxxxxxxxxxxxxxxxxxxxEChE̍쐬
  m_hWnd = CreateWindowEx( WS_EX_TOOLWINDOW,//|WS_EX_TRANSPARENT,
                         WINDOWCLASS_DLL, NULL, WS_POPUP,
                         0, 0, 0, 0,
                         m_hDesktop, NULL, m_hInstance, (LPVOID)this);

  if (!m_hWnd) {
    MessageBox(0,TEXT("failed to create window."),WINDOWCLASS_DLL,MB_OK|MB_SYSTEMMODAL);
    return;
  }

  //xxxxxxxxxxxxxxxxxxxxLITESTEP ɃW[o^
  SendMessage( m_hLitestep, LM_REGISTERMESSAGE, (WPARAM) m_hWnd, (LPARAM) nMessages );
  SetWindowLong( m_hWnd, GWL_USERDATA, (LONG)MAGICDWORD );

  //xxxxxxxxxxxxxxxxxxxxݒ̓ǂݍ݂Ɣf
  InitSettings();

  SetWindowPos(m_hWnd, (m_bAlwaysOnTop) ? HWND_TOPMOST:HWND_TOP, 0, 0, m_Width, m_Height, SWP_NOMOVE|SWP_NOACTIVATE);
  SetWndPos();

  //xxxxxxxxxxxxxxxxxxxx Ia`mf̒ǉ

  PushBangEntries(&bsBang, "!GandharvaToggle", bangToggleVisible, TRUE);
  PushBangEntries(&bsBang, "!GandharvaToggleTime", bangToggleTime);
  PushBangEntries(&bsBang, "!GandharvaShow", bangShow);
  PushBangEntries(&bsBang, "!GandharvaHide", bangHide);
  PushBangEntries(&bsBang, "!GandharvaDispMenu", bangDispMenu);
  PushBangEntries(&bsBang, "!GandharvaSndvol", bangRunSndvol);
  PushBangEntries(&bsBang, "!GandharvaToggleOnTop", bangToggleOnTop);
  PushBangEntries(&bsBang, "!GandharvaOnTop", bangOnTop);
  PushBangEntries(&bsBang, "!GandharvaNotOnTop", bangNotOnTop);

  if(m_swCmdMode){
    PushBangEntries(&bsBangExt, "!GandharvaCmdPrev", bangAmpPrev, TRUE);
    PushBangEntries(&bsBangExt, "!GandharvaCmdPlay", bangAmpPlay);
    PushBangEntries(&bsBangExt, "!GandharvaCmdPause", bangAmpPause);
    PushBangEntries(&bsBangExt, "!GandharvaCmdStop", bangAmpStop);
    PushBangEntries(&bsBangExt, "!GandharvaCmdNext", bangAmpNext);
    PushBangEntries(&bsBangExt, "!GandharvaCmdPLEdit", bangAmpPLEdit);
    PushBangEntries(&bsBangExt, "!GandharvaCmdOpenFile", bangAmpOpenFile);
    PushBangEntries(&bsBangExt, "!GandharvaCmdPower", bangAmpPower);
    PushBangEntries(&bsBangExt, "!GandharvaCmdExtension", bangAmpCommand);
  }

  AddBangCommandEntries(&bsBang);
  AddBangCommandEntries(&bsBangExt);

  //xxxxxxxxxxxxxxxxxxxx winamp stuff
  char *buf=new char[MAX_TITLE_SIZE];

  //ftHg
  if(NULL == *m_lpszTitleDefault)
    onLmGetRevid(LM_GETREVID, 0, (LPARAM)buf);
  else
    strncpy(buf, m_lpszTitleDefault, MAX_TITLE_SIZE-1);

  if(m_uiPlayerType == 3){
    m_pPlayer = new CWinamp3Function(buf);
  } else {
    m_pPlayer = new CWinampFunction(buf);
  }
  
  delete buf;

  //xxxxxxxxxxxxxxxxxxxx^C}[
  if(NULL == (m_rtimer = SetTimer(m_hWnd, TIMERID_RECYCLE_DISPLAY, 1000, NULL)))
    MessageBox(0,TEXT("Fail to create timer for title refresh."),WINDOWCLASS_DLL,MB_OK|MB_SYSTEMMODAL);

  //؂ĂǂH
  onTimer(WM_TIMER, TIMERID_RECYCLE_DISPLAY, 0);

  //xxxxxxxxxxxxxxxxxxxxEBhE̕\
  ShowWindow( m_hWnd,  !m_bVisible ? SW_HIDE : SW_SHOWNOACTIVATE );

  return;
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	fXgN^
		EChE̔j
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
Gandharva::~Gandharva()
{
  //xxxxxxxxxxxxxxxxxxxx winampt@NV
  if(m_pPlayer)
    delete m_pPlayer;
  m_pPlayer = NULL;

  //xxxxxxxxxxxxxxxxxxxx Ia`mf̍폜
  RemoveBangCommandEntries(&bsBang);
  RemoveBangCommandEntries(&bsBangExt);

  //xxxxxxxxxxxxxxxxxxxx W[o^̔j
  SendMessage( m_hLitestep, LM_UNREGISTERMESSAGE, (WPARAM) m_hWnd, (LPARAM) nMessages );

  //xxxxxxxxxxxxxxxxxxxx ^C}[̍폜ݒNX̍폜
  if(m_rtimer)
    KillTimer(m_hWnd, TIMERID_RECYCLE_DISPLAY);
  if(m_stimer)
    KillTimer(m_hWnd, TIMERID_SCROLL_INTERVAL);
  if(m_wtimer)
    KillTimer(m_hWnd, TIMERID_WAIT_PLAY);

  //xxxxxxxxxxxxxxxxxxxx EChEiNXj̔j
  DestroyWindow( m_hWnd );
  m_hWnd = NULL;

  UnregisterClass( WINDOWCLASS_DLL, m_hInstance );

  return;
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	EChËړ
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
void Gandharva::SetWndPos()
{
  int x,y;

  x = m_PosX;
  y = m_PosY;

  if(m_bXFromCenter) {
    x += GetSystemMetrics(SM_CXSCREEN)/2;
  } else {
    if(x < 0)
      x += GetSystemMetrics(SM_CXSCREEN);
  }

  if(m_bYFromCenter) {
    y += GetSystemMetrics(SM_CYSCREEN)/2;
  } else {
    if(y < 0)
      y += GetSystemMetrics(SM_CYSCREEN);
  }

  SetWindowPos(m_hWnd, NULL, x, y, 0, 0, SWP_NOSIZE|SWP_NOACTIVATE|SWP_NOZORDER);
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	EChEvV[W
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
LRESULT CALLBACK Gandharva::WndProc(HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam)
{
  Gandharva *pGandharva;

  // EChE쐬O
  if(message == WM_NCCREATE){
    LPCREATESTRUCT lpcs = (LPCREATESTRUCT)lparam;
    pGandharva = (Gandharva *)lpcs->lpCreateParams;

    SetWindowLong(hwnd, 0, (long)pGandharva);
  }else
    pGandharva = (Gandharva *)GetWindowLong(hwnd, 0);

  //bZ[WtB^
  if(message == WM_SYSKEYDOWN) return 0;

  if(pGandharva)
    //vV[W
    return pGandharva->WindowProc(hwnd, message, wparam, lparam);

  // C̃|C^߂Ȃꍇ
  return DefWindowProc(hwnd, message, wparam, lparam);
}

//Gandharva::WindowProc
BEGIN_MESSAGE_PROC(Gandharva)
  MESSAGEFUNC(onPaint,          WM_PAINT);
  MESSAGEFUNC(onTimer,          WM_TIMER);
  MESSAGEFUNC(onDisplayChange,  WM_DISPLAYCHANGE);
  MESSAGEFUNC(onMouse,          WM_MBUTTONDBLCLK);
  MESSAGEFUNC(onMouse,          WM_MBUTTONUP);
  MESSAGEFUNC(onMouse,          WM_LBUTTONDBLCLK);
  MESSAGEFUNC(onMouse,          WM_LBUTTONUP);
  MESSAGEFUNC(onMouse,          WM_RBUTTONDBLCLK);
  MESSAGEFUNC(onMouse,          WM_RBUTTONUP);
  MESSAGEFUNC(onLmGetRevid,     LM_GETREVID);
  MESSAGEFUNC(onCopyData,       WM_COPYDATA);
END_MESSAGE_PROC



/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
  Gandharva Command Provider Service
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
LRESULT Gandharva::onCopyData(UINT message, WPARAM wparam, LPARAM lparam)
{
  PCOPYDATASTRUCT pcpdata = (PCOPYDATASTRUCT)lparam;

  //!bang R}h͂
  if(pcpdata->dwData) {
    if(pcpdata->dwData > 40000)
      ParseAmpCommand(pcpdata->dwData);
    else
      BangProcessor(pcpdata->dwData, (LPSTR)pcpdata->lpData);
    return 0;
  }

  //o[W`FbN
  LPCMDPROVIDERSTRUCT lpcmdprov = CommandProvider::ParseCopyData(pcpdata);

  if(!m_pPlayer->m_bUseServer)
    return 0;

  if(NULL == lpcmdprov)
    return CMDPROV_STATUS_BAD_VERSION;

  //R}h
  switch(lpcmdprov->command) {
  case CMDPROV_COMMAND_OPEN:
    if(m_token != -1) return CMDPROV_STATUS_CONNECTION_REFUSED;
    m_token = 623;
    return m_token;

  case CMDPROV_COMMAND_DATA:
#if 0
    if(lpcmdprov->token != m_token) return CMDPROV_STATUS_BAD_TOKEN;
#endif
    if(lpcmdprov->title[0])
      m_pPlayer->SetTitle(lpcmdprov->title);

    m_pPlayer->SetPlaybackStatus(lpcmdprov->status);
    m_pPlayer->SetPlaybackTime(lpcmdprov->total, lpcmdprov->elapsed);
    break;

  case CMDPROV_COMMAND_CLOSE:
    if(lpcmdprov->token != m_token) return CMDPROV_STATUS_BAD_TOKEN;
    m_token = -1;

    return CMDPROV_STATUS_NOERROR;
  default:
    return CMDPROV_STATUS_BAD_VERSION;
  }

  return m_pPlayer->GetLastCommand();
}

/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	W[̃o[Wn
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
LRESULT Gandharva::onLmGetRevid(UINT message, WPARAM wparam, LPARAM lparam)
{
  UINT mode = (UINT)wparam;
  char *buffer = (char *)lparam;

  if(!buffer)
    return 0;

  //xxxxxxxxxxxxxxxxxxxx o[W
  switch(mode){
#if defined _DEBUG
  case 0:
    sprintf(buffer, "%s:debug %s %s", buildname, __DATE__, __TIME__);
    break;
#else
  case 0:
    sprintf(buffer, "%s:%s", buildname, buildver);
    break;
#endif //_DEBUG

  case 1:
    sprintf(buffer, "Id:%s %s %s %s", buildname, buildver, builddate, buildauthor);
    break;

  default:
    strcpy(buffer, "");
    break;
  }

  return (LRESULT)strlen(buffer);
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	EChE̕`
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
LRESULT Gandharva::onPaint(UINT message, WPARAM wparam, LPARAM lparam)
{
  HDC hdcScreen;
  HDC hdcTemp;
  HBITMAP hbmTemp,hbmOld;

  //xxxxxxxxxxxxxxxxxxxx `Jn
  PAINTSTRUCT ps;
  hdcScreen = BeginPaint(m_hWnd, &ps);

  //xxxxxxxxxxxxxxxxxxxx enh̍쐬
  hdcTemp = CreateCompatibleDC(hdcScreen);
  hbmTemp = CreateCompatibleBitmap(hdcScreen, m_Width, m_Height);

  //xxxxxxxxxxxxxxxxxxxx rbg}bv̓KpƃobNAbv
  hbmOld = SelectBitmap(hdcTemp, hbmTemp);

  //xxxxxxxxxxxxxxxxxxxx wi̕`
  PaintBG(hdcTemp, GPLS_REPEATSHUFFLE & m_pPlayer->GetPlayerStatus());

  //xxxxxxxxxxxxxxxxxxxx eLXgdˍ킹
  if(m_pPlayer) {
    //winamp ԕ\
    if(m_bTimeEnable){
      PaintTime(hdcTemp);
    }
  }

  //^Cg\
  int bcx,bcy;
  GetLSBitmapSize(m_hbmTitle, &bcx, &bcy);
  if(m_bTitleScroll && bcx > m_Width -(m_nPaddingRight+m_nPaddingLeft)){
    PaintText(hdcTemp);
    if(!m_stimer)
      m_stimer = SetTimer(m_hWnd, TIMERID_SCROLL_INTERVAL, m_nScrollInterval, NULL);
  } else {
    PaintTextNoScroll(hdcTemp);
    if(m_stimer){
      KillTimer(m_hWnd, TIMERID_SCROLL_INTERVAL);
      m_stimer = NULL;
    }
  }

  //xxxxxxxxxxxxxxxxxxxx wi߂H

  //xxxxxxxxxxxxxxxxxxxx EBhEɓ]
  BitBlt(hdcScreen, 0, 0, m_Width, m_Height, hdcTemp, 0, 0, SRCCOPY);

  //xxxxxxxxxxxxxxxxxxxx enh̔j
  EndPaint(m_hWnd, &ps);

  SelectBitmap(hdcTemp, hbmOld);

  DeleteBitmap(hbmTemp);
  DeleteDC(hdcTemp);

  return 0;
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	^C}[
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
LRESULT Gandharva::onTimer(UINT message, WPARAM wparam, LPARAM lparam)
{
  LPSTR lpszbuf = new char [MAX_TITLE_SIZE];
  long amptime;

  switch(wparam) {
  case TIMERID_RECYCLE_DISPLAY:
    // ԕ\̍XV ///////////////////////////
    if(m_bTimeEnable) {
      amptime = m_pPlayer->GetPlaybackTime((m_bTimeRemain)? GPT_REMAIN : GPT_ELAPSED);
      UpdateTimeStrBitmap(amptime);
    }
    // ^Cg\̍XV ///////////////////////
    if(m_pPlayer && lpszbuf) {
      if(m_pPlayer->GetTitle(lpszbuf, GWT_REFRESH)) {
        //^CgXVꂽ
        m_nScrollOffset = 0;
        m_pPlayer->SetFormat(lpszbuf, !m_bKeepPrefix, !m_bKeepSuffix);
        UpdateTitleStrBitmap(lpszbuf);
      }
    } else {
      // error
      UpdateTitleStrBitmap ("fatal error on timer...");
    }
    
    InvalidateRect(m_hWnd, NULL, FALSE);
    break;

  case TIMERID_SCROLL_INTERVAL:
    /* XN[p荞 */
    m_nScrollOffset += m_nScrollStep;
    InvalidateRect(m_hWnd, NULL, FALSE);
    break;

  case TIMERID_WAIT_PLAY:
    /* 1secƂɌĂŃEChE邩mF */
    --m_nWaitCounter;
    
    if(m_pPlayer->FindWindow()) {
      m_pPlayer->PostCommand(AMPAPI_CMD_PLAY);
      m_nWaitCounter = 0;
    }

    //^C}[I
    if(m_nWaitCounter<=0) {
      KillTimer(m_hWnd, TIMERID_WAIT_PLAY);
      m_wtimer = 0;
      m_nWaitCounter = 0;
    }
    break;
  }

  delete lpszbuf;
  return 0;
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	fBXvC̉𑜓xύXꂽƂ
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
LRESULT Gandharva::onDisplayChange(UINT message, WPARAM wparam, LPARAM lparam)
{
  SetWndPos();
  return 0;
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	}EXCxg
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
LRESULT Gandharva::onMouse(UINT message, WPARAM wparam, LPARAM lparam)
{
  DWORD cmap = ParseClickMap(LOWORD(lparam), HIWORD(lparam));

  int button,num;

  switch(message) {
  case WM_LBUTTONUP: //Left Button Click
    button=MOUSEMAP_LEFT; num=MOUSEMAP_CLICK; break;
  case WM_RBUTTONUP: //Right Button Click
    button=MOUSEMAP_RIGHT; num=MOUSEMAP_CLICK; break;
  case WM_MBUTTONUP: //Middle Button click
    button=MOUSEMAP_MIDDLE; num=MOUSEMAP_CLICK; break;
  case WM_LBUTTONDBLCLK: //Left Button Double Click
    button=MOUSEMAP_LEFT; num=MOUSEMAP_DBLCLK; break;
  case WM_RBUTTONDBLCLK: //Right Button Double Click
    button=MOUSEMAP_RIGHT; num=MOUSEMAP_DBLCLK; break;
  case WM_MBUTTONDBLCLK: //Middle Button Double Click
    button=MOUSEMAP_MIDDLE; num=MOUSEMAP_DBLCLK; break;
  }

  if(MyParseBangCommand(m_lpszMouseMap[ MOUSEMAP_ALL ][button][num])) return 0;

  if(PCM_TITLE & cmap){ MyParseBangCommand(m_lpszMouseMap[ MOUSEMAP_TITLE ][button][num]); return 0; }
  if(PCM_TIME & cmap) { MyParseBangCommand(m_lpszMouseMap[ MOUSEMAP_TIME  ][button][num]); return 0; }

  return 0;
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	}EXCxg̍W
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
DWORD Gandharva::ParseClickMap(int mx, int my)
{
  DWORD dwresult=0;

  if(m_nPaddingLeft <= mx
     && m_Width - m_nPaddingRight >= mx
     && m_nPaddingTop <= my
     && m_Height - m_nPaddingBottom >= my)
      dwresult |= PCM_TITLE;
      
  if(m_nATPaddingLeft <= mx
     && m_Width - m_nATPaddingRight >= mx
     && m_nATPaddingTop <= my
     && m_Height - m_nATPaddingBottom >= my)
      dwresult |= PCM_TIME;

  return dwresult;
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	ParseBangCommand wrapper
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
BOOL Gandharva::MyParseBangCommand(char *command)
{
  if(!command)
    return FALSE;

  LPSTR lpszcmd,lpszargs;
  BOOL result;

  lpszcmd = new char[1024];

  //copy to temp buffer
  strncpy(lpszcmd, command, 1023);

  //It has token(s)?
  lpszargs = (LPSTR)_tcschr(lpszcmd, ' ');

  if(lpszargs)
    *lpszargs++ = NULL;
  else
    lpszargs = "";

  //support .exe file
  if(*lpszcmd != '!'){
    ShellExecute(m_hWnd, NULL, lpszcmd, lpszargs, NULL, SW_SHOWNORMAL);
    result = TRUE;
  } else {
    //arg = NULL ̓_ (2001-02-20`)
    result = ParseBangCommand(m_hWnd, lpszcmd, lpszargs);
  }
  delete lpszcmd;

  return result;
}

/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	!bang 
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
void Gandharva::BangProcessor(BANGID id, LPSTR args)
{
  HWND hwnd;

  // winamp R}h
  if(id>40000)
    ParseAmpCommand(id);

  //!bang {
  switch(id){
  case USERBM_SHOW: //!GandharvaShow
    ShowWindow(m_hWnd, SW_SHOWNOACTIVATE);
    break;

  case USERBM_HIDE: //!GandharvaHide
    ShowWindow(m_hWnd, SW_HIDE);
    break;

  case USERBM_TOGGLE: //!GandharvaToggle
    ShowWindow(m_hWnd, (IsWindowVisible(m_hWnd) ? SW_HIDE : SW_SHOWNOACTIVATE));
    break;

  case USERBM_TOGGLE_TIME: //!GandharvaToggleTime
    m_bTimeRemain=(m_bTimeRemain)?FALSE:TRUE;
    onTimer(WM_TIMER, TIMERID_RECYCLE_DISPLAY, 0);
    break;

  case USERBM_DISPMENU: //!GandharvaDispMenu
    m_pPlayer->DisplayMainMenu();
    break;

  case USERBM_SNDVOL: //!GandharvaSndVol
    hwnd = FindWindow("Volume Control", NULL);

    if(!hwnd)
      ShellExecute(m_hWnd, NULL, "sndvol32.exe", NULL, NULL, SW_SHOWNORMAL);
    else
      SetForegroundWindow(hwnd);

    break;

  case USERBM_TOGGLE_ONTOP: //!GandharvaToggleOnTop
    m_bAlwaysOnTop = !(GetWindowLong(m_hWnd, GWL_EXSTYLE) & WS_EX_TOPMOST);
    SetWindowPos(m_hWnd, m_bAlwaysOnTop?HWND_TOPMOST:HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
    break;

  case USERBM_ONTOP: //!GandharvaOntop
    m_bAlwaysOnTop = TRUE;
    SetWindowPos(m_hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
    break;

  case USERBM_NOT_ONTOP: //!GandharvaNotOntop
    m_bAlwaysOnTop = FALSE;
    SetWindowPos(m_hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
    break;

  case USERBM_AMP_POWER: //cmdpower
    if(!m_pPlayer)
      break;
    
    if( m_pPlayer->FindWindow() )
      m_pPlayer->Close();
    else
      m_pPlayer->ExecuteEx(NULL, m_bVisibleAmp);
    break;

  case USERBM_AMP_COMMANDEX: //cmdextension
    if(args)
      ParseAmpCommand( atoi(args) );
    break;

  }
  return;
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	!bang  winamp message
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
LRESULT Gandharva::ParseAmpCommand(DWORD command)
{
  //xxxxxxxxxxxxxxxxxxxx JĂȂ͈͂̃bZ[W̓tB^O
  if(command <= 40000 || 40299 <= command)
    return 1;

  //xxxxxxxxxxxxxxxxxxxx 
  HWND hPlayer = m_pPlayer->FindWindow();

  switch(command){
  case AMPAPI_CMD_PLAY: //cmdplay
    if(!hPlayer){
      m_pPlayer->ExecuteEx(NULL, m_bVisibleAmp);

      if(m_nCmdPlayTimeout>0 && !m_wtimer) {
        m_nWaitCounter = m_nCmdPlayTimeout;
        m_wtimer = SetTimer(m_hWnd, TIMERID_WAIT_PLAY, 1000, NULL);
      } else
        return 0;
    }
    break;
  case AMPAPI_CMD_PLEDIT: //cmdpledit
  case AMPAPI_CMD_OPENFILE: //cmpopenfile
    if(hPlayer)
      SetWindowPos(hPlayer, HWND_TOP, 0, 0, 0, 0, SWP_NOSIZE|SWP_NOMOVE);
    break;
  }

  //xxxxxxxxxxxxxxxxxxxxR}h𑗂
  m_pPlayer->PostCommand(command);
  return 0;
}
