/*

  Nullsoft WASABI Source File License

  Copyright 1999-2001 Nullsoft, Inc.

    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.


  Brennan Underwood
  brennan@nullsoft.com

*/

/* copyright (C) 2002 HOSHINO Yoshifumi (Yoshi) */


// This is essentially the same project as example1, without all the comments
// and with a less complex window.

//
// Always start with std.h
#include "c:/Wasabi SDK/studio/bfc/std.h"
//
#include "gclient.h"     //EDITME
#include "resource.h"
#include "gclientwnd.h"  //EDITME
//
#include "c:/Wasabi SDK/studio/common/xlatstr.h"
// Window creation services includes.
#include "c:/Wasabi SDK/studio/studio/services/creators.h"
#include "c:/Wasabi SDK/studio/bfc/wndcreator.h"


static WACNAME wac;
WACPARENT *the = &wac;

// {DC112483-49B5-4e6a-85B2-EC3443D0D931}
static const GUID guid = 
{ 0xdc112483, 0x49b5, 0x4e6a, { 0x85, 0xb2, 0xec, 0x34, 0x43, 0xd0, 0xd9, 0x31 } };



WACNAME::WACNAME() : WACPARENT("Gandharva Command Client For Winamp3") {
  // So, what did we want to do again?  Oh yes...

  // 1) we are going to make a window,
  registerService(new WndCreateCreatorSingle< CreateWndByGuid<GenericWnd> >);

  // 2) and have it be listed in the Thinger,
  registerService(new WndCreateCreatorSingle< CreateBucketItem<GenericWnd> >);

  // 3) and in the main context menu.
  registerAutoPopup(getGUID(), getName());
}

WACNAME::~WACNAME() {
}

GUID WACNAME::getGUID() {
  return guid;
}

void WACNAME::onCreate() {
  // *** Do startup stuff here that doesn't require you to have a window yet
}

void WACNAME::onDestroy() {
}

